/****************************************************************************/
/* CVICLT.C: All the data and code pertaining to the client are contained   */
/* in this module. It consists mostly of user interface control callbacks   */
/* where appropriate responses to user events are generated.                    */
/****************************************************************************/


/****************************************************************************/
/*                          Include Files                                   */
/****************************************************************************/
#include <userint.h>
#include <ddesupp.h>
#include "cvisvr.h"
#include "cvidde.h"

int CVICALLBACK CltCallback (unsigned handle, char *topicName,
                       char *itemName, int xType, int dataFmt,
                       int dataSize, void *dataPtr,
                       void *callbackData);


/****************************************************************************/
/* Callback for all the controls for the client.                            */
/****************************************************************************/
int CVICALLBACK ClientCtrlsCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
    char    buffer[100]={0};
    static  int handle=-1;

    if (event==EVENT_COMMIT) {
        switch (control) {
            case SERVER_SENDCOMMAND:
                if (handle==-1)
                    break;
                GetCtrlVal (panel, SERVER_COMMANDSTRING, buffer);
                if (buffer[0]!=0)
                    ClientDDEExecute (handle, buffer, 0);
                break;
            case SERVER_DISCONNECTVBSERVER:
                if (handle!=-1) {
                    DisconnectFromDDEServer (handle);
                    handle = -1;
                }
                break;
            case SERVER_CONNECTVBSERVER:
                if (handle==-1)
                    ConnectToDDEServer (&handle, "VBDDE", "System", CltCallback, 0);
                break;
        }
    }
    return FALSE;
}


/****************************************************************************/
/* DDE client callback. This function receives and handles all messages     */
/* sent by VB server (server written in Visual Basic). The type of message  */
/* is determined by the 'xType' parameter. In this program we do not react  */
/* to any request, thus we always return FALSE as the default value.        */
/****************************************************************************/
int CVICALLBACK CltCallback (unsigned handle, char *topicName,
                       char *itemName, int xType, int dataFmt,
                       int dataSize, void *dataPtr,
                       void *callbackData)
{
    return FALSE;
}
