/****************************************************************************/
/* CVIDDE.PRJ: This program demonstrates how to use the DDE Library. It     */
/* implemented both a server and a client, and uses DDE to communicate with */
/* a program written in Visual Basic. The Visual Basic program also         */
/* implemented both a server and a client, which communicate with the       */
/* client and server implemented in CVI respectively.                       */
/****************************************************************************/


/****************************************************************************/
/* CVIDDE.C: This module contains the thinnest layer of code necessary to   */
/* maintain separation between server and client. Its main functions are to */
/* initialize and terminate the program, and dispatch user interface idle   */
/* events (through the use of the Main Callback) for processing by the      */
/* server and client.                                                       */
/****************************************************************************/


/****************************************************************************/
/*                          Include Files                                   */
/****************************************************************************/

#include <cvirte.h>    /* Needed if linking in external compiler; harmless otherwise */
#include <userint.h>    /* InstallMainCallback(), RunUserInterface() */
#include <stdio.h>      /* NULL */
#include "cvisvr.h"     /* TRUE, FALSE, ActivateServer(), ActivateClient(),
                           DeactivateServer(), DeactivateClient(),
                           ProcessServerIdleEvent(), ProcessClientIdleEvent() */

/****************************************************************************/
/*                          Macro Definitions                               */
/****************************************************************************/

/****************************************************************************/
/*                          Global Variables                                */
/****************************************************************************/

/****************************************************************************/
/*                          Function Prototypes                             */
/****************************************************************************/

int CVICALLBACK MainCallback (int panelOrMenuBar, int controlOrMenuItem, int event,
        void *callbackData, int eventData1, int eventData2);


/****************************************************************************/
/*                          Function Definitions                            */
/****************************************************************************/

int main (int argc, char *argv[])
{
    if (InitCVIRTE (0, argv, 0) == 0)    /* Needed if linking in external compiler; harmless otherwise */
        return -1;    /* out of memory */
    
    InstallMainCallback (MainCallback, NULL, TRUE);
    SetIdleEventRate (200);

    ActivateServer();
    RunUserInterface();     /* the server will eventually terminate this call */
    DeactivateServer();

    return 0;
}


/****************************************************************************/
/* Filters out all events except idle events, and sends them to the server  */
/* and the client. All parameters are disregarded.                          */
/****************************************************************************/
int CVICALLBACK MainCallback (int panelOrMenuBar, int controlOrMenuItem, int event,
    void *callbackData, int eventData1, int eventData2)
{
    if (event == EVENT_IDLE) {
        ProcessServerIdleEvent();
#if 0    /* formerly excluded lines */
        ProcessClientIdleEvent();
#endif   /* formerly excluded lines */
        }

    return FALSE;           /* FALSE --> event should not be swallowed */
}
