/****************************************************************************/
/* SERVER.H: This file contains the public communication protocols which    */
/* the server exports, so that communication with clients is possible. Also,*/
/* for the sake of convenience, prototypes and macros used by SRVCLT.C were */
/* placed here.                                                             */
/****************************************************************************/


#ifndef SERVER_HEADER
#define SERVER_HEADER

/****************************************************************************/
/*                          Macro Definitions                               */
/****************************************************************************/

#define NAME        "Test Server"   /* name under which server will be registered */
#define TOPIC       "DDE Test"      /* topic of the conversation */
#define KNOB_ITEM   "Knob"          /* data item used for hot link (advisory
                                       loop). The data consists of a simple
                                       integer, being controlled by a knob in the
                                       server's front panel */
#define COMMAND     "ToggleAuto"    /* command supported by the server. The
                                       client has the ability to toggle the auto
                                       mode status of the server by issuing this
                                       command */
#define WAIT        5000            /* timeout threshold (in milliseconds) for
                                       DDE message requests which require it */

#define TRUE    1
#define FALSE   0

/****************************************************************************/
/*                          Global Variables                                */
/****************************************************************************/

/****************************************************************************/
/*                          Function Prototypes                             */
/****************************************************************************/

void    ActivateServer (void);
void    DeactivateServer (void);
void    ProcessServerIdleEvent (void);
void    ProcessClientIdleEvent (void);
void    ActivateClient (void);
void    DeactivateClient (void);

#endif /* SERVER_HEADER */
